Index: DVBScan.cs
===================================================================
--- DVBScan.cs	(revision 6)
+++ DVBScan.cs	(working copy)
@@ -14,7 +14,8 @@
 {
   public class DVBScanUtilPlugin : ITvServerPlugin
   {
-    static public TvService.TVController Controller;
+    static public TvService.TVController Controller;
+    private System.Timers.Timer _scheduleTimer;
 
     #region Constructor
 
@@ -25,17 +26,36 @@
 
     #endregion
     /// Starts the plugin
-    /// </summary>
-    public void Start(IController controller)
-    {
-      Controller = controller as TvService.TVController;
-
-      Log.Debug("DVBScanUtilPlugin Started");
-
-      Thread DVBScanUtilPlugin = new Thread(DoWork);
-      DVBScanUtilPlugin.IsBackground = true;
-      DVBScanUtilPlugin.Name = "DVBScanUtilPlugin";
-      DVBScanUtilPlugin.Start();
+    /// </summary>
+    public void Start(IController controller)
+    {
+        Controller = controller as TvService.TVController;
+
+        Log.Debug("DVBScanUtilPlugin Started");
+
+        Thread DVBScanUtilPlugin = new Thread(DoWork);
+        DVBScanUtilPlugin.IsBackground = true;
+        DVBScanUtilPlugin.Name = "DVBScanUtilPlugin";
+        DVBScanUtilPlugin.Start();
+
+        //set timer to 4 AM
+        _scheduleTimer = new System.Timers.Timer();
+        DateTime timeToScan = new DateTime();
+        if (DateTime.Now.Hour < 4)
+        {
+            timeToScan = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, 4, 0, 0);
+        }
+        else
+        {
+            timeToScan = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day + 1, 4, 0, 0);
+
+        }
+        Log.Debug("DVBScanUtilPlugin time to grab is " + timeToScan);
+        TimeSpan interval = timeToScan.Subtract(DateTime.Now);
+        _scheduleTimer.Interval = interval.TotalMilliseconds;
+        _scheduleTimer.Enabled = true;
+        _scheduleTimer.AutoReset = false;
+        _scheduleTimer.Elapsed += new System.Timers.ElapsedEventHandler(_scheduleTimer_Elapsed);
     }
 
     /// <summary>
@@ -42,9 +62,28 @@
     /// Stops the plugin
     /// </summary>
     public void Stop()
-    {
+    {
+        if (_scheduleTimer != null)
+        {
+            _scheduleTimer.Enabled = false;
+            _scheduleTimer.Dispose();
+            _scheduleTimer = null;
+        }
+    }
+
+    private void _scheduleTimer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
+    {
+        _scheduleTimer.Enabled = false;
+        Log.Debug("DVBScanUtilPlugin Scheduled Start");
+        Thread DVBScanUtilPlugin = new Thread(DoWork);
+        DVBScanUtilPlugin.IsBackground = true;
+        DVBScanUtilPlugin.Name = "DVBScanUtilPlugin";
+        DVBScanUtilPlugin.Start();
+        DateTime timeToScan = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day + 1, 4, 0, 0);
+        _scheduleTimer.Interval = timeToScan.Subtract(DateTime.Now).TotalMilliseconds;
+        _scheduleTimer.Start();
+        Log.Debug("DVBScanUtilPlugin time to grab is " + timeToScan);
     }
-
     public string Author
     {
       get { return "regeszter"; }
